/* Zadatak 5d (LaTeX tekst zadatka):

Napišite program koji učitava prirodne brojeve sve dok ne učita broj koji
\textbf{ne} završava znamenkom $8$ u dekadskom sustavu.
Od svih učitanih brojeva, uključujući i zadnji, program treba ispisati onaj
učitani broj koji daje najmanji obrnuti broj.
Obrnuti broj nekog broja dobiva se tako da se broju obrne poredak znamenki
u dekadskom sustavu.

Primjer: Ako su redom učitani brojevi $168$, $148$ i $2590$, za obrnute
brojeve vrijedi $841 < 861 < 952$. Program treba ispisati broj $148$.

*/

#include <stdio.h>

  /* Namjerno NEMA funkcije za nalazenje obratnog broja,
     nego je sve napravljeno u glavnom programu.
     Rjesenje s takvom funkcijom bi bilo jednostavnije,
     jer ne treba dodatnu pomocnu varijablu za pamcenje
     polaznog broja, kod generiranja obratnog. */

int main(void)
{
        /* Logicki indikatori: prvi = sljedeci broj je prvi
           (za inicijalizaciju min.), radi = nije zadnji clan niza.
           Prvi je inicijaliziran na 1 (istina), a drugog
           postavljamo u petlji koja cita brojeve. */
    int prvi = 1, radi;
         /* Ucitani broj, pomocni i obratni broj, najmanji obratni
            i pripadni ucitani broj (taj se trazi). */
    int broj, pom, obratni, min_obr, pripadni;

        /* Kozmetika za rucno upisivanje brojeva. */
    printf(" Upisi niz brojeva, zadnji ne zavrsava znamenkom 8:\n");

        /* Petlja za citanje (bez dodatnog teksta za upis). */
    do {
            /* Ucitaj sljedeci broj. */
        scanf("%d", &broj);

            /* Provjeri odmah da nije zadnji. */
        radi = broj % 10 == 8;

            /* Obradi broj. Prvo nadji njegov obratni.
               Unistavamo pomocnu kopiju broja (pom). */
        pom = broj;
        obratni = 0;
        while (pom > 0) {
            obratni = obratni * 10 + pom % 10;
            pom /= 10;
        }

            /* Provjeri je li prvi ili novi najmanji.
               Koristi skraceno racunanje logickih izraza! */
        if (prvi || obratni < min_obr) {
            min_obr = obratni;
            pripadni = broj;
            prvi = 0;
        }

            /* Kontrolni ispis. */
        printf("  broj = %7d, obratni = %7d, min_obr = %7d\n",
               broj, obratni, min_obr);

    } while (radi);

        /* Ispis trazenog broja. */
    printf("\n Trazeni broj = %d\n", pripadni);

    return 0;
}
